-- MoonTimeLayoutObj.lua

function MoonTimeLayoutObj()
	-- dieses Frame besitzt die Funktionen:
	-- GetStarrainCD
	-- GetTreantsCD
	-- GetStarsurgeCD
	-- GetMoonfireCD
	-- GetInsectSwarmCD
	-- GetEclipseEndTimes
	-- Next()
	local frame = CreateFrame( "Frame" )
	
	frame.GetStarfallDuration = function()
		local _, _, _, _, _, _, expirationTime = UnitBuff("player", SR_name) 
		
		if expirationTime == nil then 
			return 0
		end
		
		return expirationTime-GetTime();
	end
	
	frame.GetStarfallCD = function()
		local start, duration, enabled = GetSpellCooldown(SR_id);
		return start+duration-GetTime();
	end
	
	frame.GetTreantsCD = function()
		local start, duration, enabled = GetSpellCooldown(Treants_id);
		
		return start+duration-GetTime();
	end

	frame.GetStarsurgeCD = function()
		local start, duration, enabled = GetSpellCooldown(SS_id);
		return start+duration-GetTime();
	end

	frame.GetMoonfireCD = function()
		local _, _, _, _, _, duration, MF_expirationTime, MF_unitCaster = UnitDebuff("target", MF_name);
		
		if MF_unitCaster=="player" then
			return MF_expirationTime-GetTime(), duration;
		else
			return -1, GetTime();
		end
	end

	frame.GetSunfireCD = function()
		local _, _, _, _, _, duration, SunF_expirationTime, SunF_unitCaster = UnitDebuff("target", SunF_name);
		
		if SunF_unitCaster=="player" then
			return SunF_expirationTime-GetTime(), duration;
		else
			return -1, GetTime();
		end
	end

	frame.GetInsectSwarmCD = function()
		local _, _, _, _, _, _, IS_expirationTime, IS_unitCaster = UnitDebuff("target", IS_name);
		
		if IS_unitCaster=="player" then
			return IS_expirationTime-GetTime();
		else
			return -1;
		end
	end
	
	frame.GetFaerieFireCD = function()
		local _, _, _, _, _, _, FF_expirationTime, FF_unitCaster = UnitDebuff("target", FF_name);
		
		if FF_unitCaster=="player" then
			return FF_expirationTime-GetTime();
		else
			return -1;
		end
	end
	
	frame.GetCelestialAlignmentCD = function()
		local start, duration, enabled = GetSpellCooldown(CA_id);
		return start+duration-GetTime();
	end	

	frame.GetTalentCD = function( self, talentNumber )
		local name, texture = GetTalentInfo(talentNumber)
		local start, duration, enabled = GetSpellCooldown(name);	
			
		return start+duration-GetTime();
	end

	frame.GetRejuvenationDuration = function()
		local _, _, _, _, _, duration, R_expirationTime, R_unitCaster = UnitBuff("player", R_name);
		
		if R_unitCaster=="player" then
			return R_expirationTime-GetTime(), duration;
		else
			return -1;
		end			
	end	
	
	

	
		local ttd = {
	
	["hp"] = 0,
	["timestamp"] = 0,
	["ttd"] = 0,
};
	
	frame.TimeTillDeath = function ()
	
		tmp = GetTime()
		
		if tmp - 1 > ttd["timestamp"] then
			local hpdiff = ttd["hp"]-UnitHealth("target")
			local timediff = tmp-ttd["timestamp"]
			local timetilldeath = UnitHealth("target")/hpdiff*timediff
			
			if timetilldeath then
				ttd["ttd"] = timetilldeath
			end
		
		
			ttd["hp"] = UnitHealth("target")
			ttd["timestamp"] = tmp
		
		end
		
		return ttd["ttd"] 
		
		
		
	end
	
	frame.GetEclipseDirection = function()
		local dir = GetEclipseDirection()
		
		--DEFAULT_CHAT_FRAME:AddMessage(dir)
		
		if ( dir == "none" ) then
			dir = "sun";
		end
		local power = UnitPower("player", 8)
		
		return dir, power
	end

	frame.isSolar = function()
		local name, _, _, _, _, _, solar_expirationTime, _, _, _, _ = UnitBuff("player", Solar_name);
		if ( name ) then
			return true
		else
			return false
		end
	end

	frame.isLunar = function()
		local name, _, _, _, _, _, solar_expirationTime, _, _, _, _ = UnitBuff("player", Lunar_name);
		if ( name ) then
			return true
		else
			return false
		end
	end	


	frame.GetCelestialAlignmentDuration = function()
		local name, _, _, _, _, _, CD_expirationTime, _, _, _, _ = UnitBuff("player", CA_name);

		if name then
			return CD_expirationTime-GetTime();
		else
			return -1
		end
	end	
	
	frame.getFuturePower = function(self, spell, EDir, EPower)
		if endTime == nil then endTime = 0 end

		
		local change = 0;

		if spell == SF_name and EDir == "sun" then
			change = 20;
		end

		if spell == W_name and EDir == "moon"  then
			change = -15;
		end

		if spell == SS_name then
			if EDir == "moon" then
				change = -20;
			else
				change = 20;
			end
		end

		if not frame:isSolar() and not frame:isLunar() then
			change = 2*change;
		end

		EPower = EPower + change;
	return EPower
	
	end


		




	return frame
end
		
	